=== modified file 'www/media/browser/browser.js'
--- www/media/browser/browser.js	2008-07-23 07:38:03 +0000
+++ www/media/browser/browser.js	2008-08-05 02:06:49 +0000
@@ -307,8 +307,8 @@
     var isdir = response.getResponseHeader("X-IVLE-Return") == "Dir";
     if (isdir)
     {
-        setup_for_dir_listing(listing, subjects);
-        handle_dir_listing(path, listing);
+        setup_for_listing();
+        home_listing(listing, subjects, path);
     }
     else
     {

=== modified file 'www/media/browser/listing.css'
--- www/media/browser/listing.css	2008-07-27 11:44:59 +0000
+++ www/media/browser/listing.css	2008-08-05 02:06:49 +0000
@@ -186,6 +186,7 @@
 
 #specialhome {
     background-color: #ddd;
+    border-bottom: 1px solid black;
 }
 #specialhome h2 {
     background-color: #aaa;

=== modified file 'www/media/browser/listing.js'
--- www/media/browser/listing.js	2008-07-23 07:38:03 +0000
+++ www/media/browser/listing.js	2008-08-05 02:06:49 +0000
@@ -551,11 +551,11 @@
     update_selection();
 }
 
-/** Initialises the DOM elements required to present a dir listing,
+/** Initialises the DOM elements required to present files window,
  * assuming that clear_page has just been called or the page just
  * loaded for the first time.
  */
-function setup_for_dir_listing(listing, subjects)
+function setup_for_listing()
 {
     var filesbody = document.getElementById("filesbody");
 
@@ -573,9 +573,34 @@
     var filetablediv = document.createElement("div");
     filetable.appendChild(filetablediv);
     filetablediv.setAttribute("id", "filetablediv");
-    /* Do the home listing */
-    if (subjects != null)
-        home_listing(listing, subjects);
+
+    /* Side-panel */
+    /* 2 nested divs, so we can set the width exactly and have padding inside
+     * of that */
+    var sidepanel_outer = document.createElement("div");
+    middle.appendChild(sidepanel_outer);
+    sidepanel_outer.setAttribute("id", "sidepanel_outer");
+    var sidepanel = document.createElement("div");
+    sidepanel_outer.appendChild(sidepanel);
+    sidepanel.setAttribute("id", "sidepanel");
+
+    /* Now after the table "middle", there is a status bar */
+    var statusbar_outer = document.createElement("div");
+    filesbody.appendChild(statusbar_outer);
+    statusbar_outer.setAttribute("id", "statusbar_outer");
+    var statusbar = document.createElement("div");
+    statusbar_outer.appendChild(statusbar);
+    statusbar.setAttribute("id", "statusbar");
+}
+
+/** Sets up the DOM elements required to present a directory liisting.
+ */
+function setup_dir_listing()
+{
+    var filesbody = document.getElementById("filesbody");
+    var filetable = document.getElementById("filetable");
+    var filetablediv = document.getElementById("filetablediv");
+
     /* A nested table within this div - the actual files listing */
     var filetabletable = document.createElement("table");
     filetablediv.appendChild(filetabletable);
@@ -607,34 +632,17 @@
     var filetabletbody = document.createElement("tbody");
     filetabletable.appendChild(filetabletbody);
     filetabletbody.setAttribute("id", "files");
-
-    /* Side-panel */
-    /* 2 nested divs, so we can set the width exactly and have padding inside
-     * of that */
-    var sidepanel_outer = document.createElement("div");
-    middle.appendChild(sidepanel_outer);
-    sidepanel_outer.setAttribute("id", "sidepanel_outer");
-    var sidepanel = document.createElement("div");
-    sidepanel_outer.appendChild(sidepanel);
-    sidepanel.setAttribute("id", "sidepanel");
-
-    /* Now after the table "middle", there is a status bar */
-    var statusbar_outer = document.createElement("div");
-    filesbody.appendChild(statusbar_outer);
-    statusbar_outer.setAttribute("id", "statusbar_outer");
-    var statusbar = document.createElement("div");
-    statusbar_outer.appendChild(statusbar);
-    statusbar.setAttribute("id", "statusbar");
 }
 
 /** Presents the directory listing.
  */
-function handle_dir_listing(path, listing, subjects)
+function handle_dir_listing(path, listing)
 {
+    /* Add the DOM elements for the file listing */
+    setup_dir_listing()
+
     var row_toggle = 1;
-    /* Nav through the top-level of the JSON to the actual listing object. */
-    var listing = listing.listing;
-
+    
     /* Is this dir under svn? */
     var under_subversion = ("svnstatus" in current_file) && (current_file.svnstatus != "unversioned");
 

=== modified file 'www/media/browser/specialhome.js'
--- www/media/browser/specialhome.js	2008-07-27 11:44:59 +0000
+++ www/media/browser/specialhome.js	2008-08-05 02:06:49 +0000
@@ -32,72 +32,87 @@
 
 /** Present home directory 
  */
-function home_listing(listing, subjects)
+function home_listing(listing, subjects, path)
 {
-    listing = listing.listing;
+    /* Nav through the top-level of the JSON to the actual listing object. */
+    var listing = listing.listing;
+    
     var filetablediv = document.getElementById("filetablediv");
     var specialhomediv;
     var h2;
     var h3;
     var ul;
     var li;
-
-    /* Wrap all this "special" stuff in a div, for styling purposes */
-    specialhomediv = document.createElement("div");
-    specialhomediv.setAttribute("id", "specialhome");
-    filetablediv.appendChild(specialhomediv);
-
-    /* SUBJECTS Section
-    /* Create the header row */
-    if (subjects.length > 0)
+    var div;
+
+    /* Only show special headings if we get subject listings */
+    if (subjects != null)
     {
-        h2 = dom_make_text_elem("h2", "Subjects");
+        /* Wrap all this "special" stuff in a div, for styling purposes */
+        specialhomediv = document.createElement("div");
+        specialhomediv.setAttribute("id", "specialhome");
+        filetablediv.appendChild(specialhomediv);
+
+        /* SUBJECTS Section
+        /* Create the header row */
+        if (subjects.length > 0)
+        {
+            h2 = dom_make_text_elem("h2", "Subjects");
+            specialhomediv.appendChild(h2);
+        }
+
+        /* Create the contents */
+        for (var i=0; i<subjects.length; i++)
+        {
+            var subject = subjects[i];
+            var subjpath = subject.subj_short_name;
+            // Header
+            h3 = dom_make_text_elem("h3", subject.subj_name);
+            specialhomediv.appendChild(h3);
+        
+            /* Print the file listing */
+            ul = document.createElement("ul");
+            // Stuff
+            ul.appendChild(make_subject_item(subjpath, PERSONALDIR,
+                "Your own files in this subject"));
+            // Groups
+            /* TODO: List groups */
+            
+            specialhomediv.appendChild(ul);
+
+            /* Remove it from listing */
+            if (subject.subj_short_name in listing)
+                delete listing[subject.subj_short_name];
+        }
+
+        /* FIXME: Old Subjects? */
+
+        /* STUFF Section -- For the stuff directory */
+        /* Create the header */
+        h2 = dom_make_text_elem("h2", "Stuff");
         specialhomediv.appendChild(h2);
-    }
-
-    /* Create the contents */
-    for (var i=0; i<subjects.length; i++)
-    {
-        var subject = subjects[i];
-        var path = subject.subj_short_name;
-        // Header
-        h3 = dom_make_text_elem("h3", subject.subj_name);
-        specialhomediv.appendChild(h3);
-        
-        /* Print the file listing */
+        /* Create the contents */
         ul = document.createElement("ul");
-        // Stuff
-        ul.appendChild(make_subject_item(path, PERSONALDIR,
-              "Your own files in this subject"));
-        // Groups
-        /* TODO: List groups */
-            
+        ul.appendChild(make_subject_item("", "stuff",
+              "Your own files not related to a subject"));
         specialhomediv.appendChild(ul);
-
-        /* Remove it from listing */
-        if (subject.subj_short_name in listing)
-            delete listing[subject.subj_short_name];
-    }
-   
-    /* FIXME: Old Subjects? */
-
-    /* STUFF Section -- For the stuff directory */
-    /* Create the header */
-    h2 = dom_make_text_elem("h2", "Stuff");
-    specialhomediv.appendChild(h2);
-    /* Create the contents */
-    ul = document.createElement("ul");
-    ul.appendChild(make_subject_item("", "stuff",
-          "Your own files not related to a subject"));
-    specialhomediv.appendChild(ul);
-    /* Remove stuff from the listing */
-    if ("stuff" in listing)
-        delete listing["stuff"];
-
-    /* JUNK Section -- All the rest */
-    /* Create the header row */
-    h2 = dom_make_text_elem("h2", "Junk");
-    specialhomediv.appendChild(h2);
+        /* Remove stuff from the listing */
+        if ("stuff" in listing)
+            delete listing["stuff"];
+
+        /* JUNK Section -- All the rest */
+        /* Create the header row */
+        if (obj_length(listing) > 0)
+        {
+            h2 = dom_make_text_elem("h2", "Junk");
+            specialhomediv.appendChild(h2);
+            handle_dir_listing(path, listing);
+        }
+    }
+    else
+    {
+        handle_dir_listing(path, listing);
+    }
 }
 
 /* Does an series of AJAX requests to find out the properties of this folder 
@@ -225,3 +240,13 @@
     alert("Error: Could not create Subversion directory");
     return false;
 }
+
+/** Finds the length (number of user defined properties) of an object
+ */
+function obj_length(obj)
+{
+    length = 0;
+    for (prop in obj)
+        length++;
+    return length;
+}

